technology_links = 
  {
    ["basic-electronics"] = {used_in = {"basic-mapping", "electric-inserter"}, uses = {"basic-mining"}}
    ["basic-mining"] = {used_in = {"basic-electronics", "basic-logistics"}}
    ["basic-mapping"] = {used_in = {"analyse-ship"}, uses = {"basic-electronics"}}
    ["electric-inserter"] = {uses = {"basic-electronics"}}
    ["basic-logistics"] = {uses = {"basic-mining"}}
    ["analyse-ship"] = {used_in = {"electric-mining", "improved-equipment"}, uses = {"basic-mapping"}}
    ["basic-optics"] = {uses = {"improved-equipment"}}
    ["improved-equipment"] = {used_in = {"basic-optics", "basic-military", "demo-science-pack", "demo-steel-processing", "demo-logistics"}, uses = {"analyse-ship"}}
    ["basic-military"] = {used_in = {"active-defense", "repair-tech", "demo-military-equipment"}, uses = {"improved-equipment"}}
    ["electric-mining"] = {uses = {"analyse-ship"}}
    ["active-defense"] = {used_in = {"passive-defense", "demo-shooting-speed-1"}, uses = {"basic-military"}}
    ["repair-tech"] = {uses = {"basic-military"}}
    ["passive-defense"] = {used_in = {"demo-gates"}, uses = {"active-defense"}}
    ["demo-science-pack"] = {used_in = {"demo-automation-upgrade", "demo-munitions-upgrade", "demo-steel-furnace", "demo-gates"}, uses = {"improved-equipment"}}
    ["demo-steel-processing"] = {used_in = {"demo-automation-upgrade", "demo-steel-poles", "demo-munitions-upgrade", "demo-steel-furnace", "demo-gates"}, uses = {"improved-equipment"}}
    ["demo-automation-upgrade"] = {used_in = {"demo-productivity-1"}, uses = {"demo-steel-processing", "demo-science-pack"}}
    ["demo-steel-poles"] = {uses = {"demo-steel-processing"}}
    ["demo-military-equipment"] = {used_in = {"demo-munitions-upgrade"}, uses = {"basic-military"}}
    ["demo-munitions-upgrade"] = {uses = {"demo-military-equipment", "demo-steel-processing", "demo-science-pack"}}
    ["demo-steel-furnace"] = {uses = {"demo-steel-processing", "demo-science-pack"}}
    ["demo-logistics"] = {uses = {"improved-equipment"}}
    ["demo-gates"] = {uses = {"passive-defense", "demo-steel-processing", "demo-science-pack"}}
    ["demo-productivity-1"] = {uses = {"demo-automation-upgrade"}}
    ["demo-shooting-speed-1"] = {used_in = {"demo-shooting-speed-4"}, uses = {"active-defense"}}
    ["demo-shooting-speed-4"] = {uses = {"demo-shooting-speed-1"}}
    ["physical-projectile-damage-1"] = {used_in = {"physical-projectile-damage-2"}, uses = {"military"}}
    ["military"] = {used_in = {"physical-projectile-damage-1", "weapon-shooting-speed-1", "military-2", "heavy-armor"}}
    ["physical-projectile-damage-2"] = {used_in = {"physical-projectile-damage-3"}, uses = {"physical-projectile-damage-1"}}
    ["physical-projectile-damage-3"] = {used_in = {"physical-projectile-damage-4"}, uses = {"physical-projectile-damage-2"}}
    ["physical-projectile-damage-4"] = {used_in = {"physical-projectile-damage-5"}, uses = {"physical-projectile-damage-3"}}
    ["physical-projectile-damage-5"] = {used_in = {"physical-projectile-damage-6"}, uses = {"physical-projectile-damage-4"}}
    ["physical-projectile-damage-6"] = {used_in = {"physical-projectile-damage-7"}, uses = {"physical-projectile-damage-5"}}
    ["physical-projectile-damage-7"] = {uses = {"physical-projectile-damage-6", "space-science-pack"}}
    ["space-science-pack"] = {used_in = {"physical-projectile-damage-7", "stronger-explosives-7", "refined-flammables-7", "energy-weapons-damage-7", "artillery-shell-range-1", "artillery-shell-speed-1", "follower-robot-count-7", "worker-robots-speed-6", "mining-productivity-4"}, uses = {"rocket-silo", "electric-energy-accumulators", "solar-energy"}}
    ["stronger-explosives-1"] = {used_in = {"stronger-explosives-2"}, uses = {"military-2"}}
    ["military-2"] = {used_in = {"stronger-explosives-1", "military-science-pack", "cliff-explosives", "gates"}, uses = {"military", "steel-processing", "logistic-science-pack"}}
    ["stronger-explosives-2"] = {used_in = {"stronger-explosives-3"}, uses = {"stronger-explosives-1"}}
    ["stronger-explosives-3"] = {used_in = {"stronger-explosives-4"}, uses = {"stronger-explosives-2"}}
    ["stronger-explosives-4"] = {used_in = {"stronger-explosives-5"}, uses = {"stronger-explosives-3"}}
    ["stronger-explosives-5"] = {used_in = {"stronger-explosives-6"}, uses = {"stronger-explosives-4"}}
    ["stronger-explosives-6"] = {used_in = {"stronger-explosives-7"}, uses = {"stronger-explosives-5"}}
    ["stronger-explosives-7"] = {uses = {"stronger-explosives-6", "space-science-pack"}}
    ["refined-flammables-1"] = {used_in = {"refined-flammables-2"}, uses = {"flamethrower"}}
    ["flamethrower"] = {used_in = {"refined-flammables-1"}, uses = {"flammables", "military-science-pack"}}
    ["refined-flammables-2"] = {used_in = {"refined-flammables-3"}, uses = {"refined-flammables-1"}}
    ["refined-flammables-3"] = {used_in = {"refined-flammables-4"}, uses = {"refined-flammables-2"}}
    ["refined-flammables-4"] = {used_in = {"refined-flammables-5"}, uses = {"refined-flammables-3"}}
    ["refined-flammables-5"] = {used_in = {"refined-flammables-6"}, uses = {"refined-flammables-4"}}
    ["refined-flammables-6"] = {used_in = {"refined-flammables-7"}, uses = {"refined-flammables-5"}}
    ["refined-flammables-7"] = {uses = {"refined-flammables-6", "space-science-pack"}}
    ["energy-weapons-damage-1"] = {used_in = {"energy-weapons-damage-2"}, uses = {"laser", "military-science-pack"}}
    ["laser"] = {used_in = {"energy-weapons-damage-1", "laser-turrets", "combat-robotics-2"}, uses = {"optics", "battery", "chemical-science-pack"}}
    ["military-science-pack"] = {used_in = {"energy-weapons-damage-1", "military-3", "land-mine", "flamethrower", "rocketry", "laser-turrets", "energy-shield-equipment", "fusion-reactor-equipment", "combat-robotics"}, uses = {"military-2", "stone-walls"}}
    ["energy-weapons-damage-2"] = {used_in = {"energy-weapons-damage-3"}, uses = {"energy-weapons-damage-1"}}
    ["energy-weapons-damage-3"] = {used_in = {"energy-weapons-damage-4"}, uses = {"energy-weapons-damage-2"}}
    ["energy-weapons-damage-4"] = {used_in = {"energy-weapons-damage-5"}, uses = {"energy-weapons-damage-3"}}
    ["energy-weapons-damage-5"] = {used_in = {"energy-weapons-damage-6"}, uses = {"energy-weapons-damage-4"}}
    ["energy-weapons-damage-6"] = {used_in = {"energy-weapons-damage-7"}, uses = {"energy-weapons-damage-5"}}
    ["energy-weapons-damage-7"] = {uses = {"energy-weapons-damage-6", "space-science-pack"}}
    ["weapon-shooting-speed-1"] = {used_in = {"weapon-shooting-speed-2"}, uses = {"military"}}
    ["weapon-shooting-speed-2"] = {used_in = {"weapon-shooting-speed-3"}, uses = {"weapon-shooting-speed-1"}}
    ["weapon-shooting-speed-3"] = {used_in = {"weapon-shooting-speed-4"}, uses = {"weapon-shooting-speed-2"}}
    ["weapon-shooting-speed-4"] = {used_in = {"weapon-shooting-speed-5"}, uses = {"weapon-shooting-speed-3"}}
    ["weapon-shooting-speed-5"] = {used_in = {"weapon-shooting-speed-6"}, uses = {"weapon-shooting-speed-4"}}
    ["weapon-shooting-speed-6"] = {uses = {"weapon-shooting-speed-5"}}
    ["laser-turret-speed-1"] = {used_in = {"laser-turret-speed-2"}, uses = {"laser-turrets"}}
    ["laser-turrets"] = {used_in = {"laser-turret-speed-1", "personal-laser-defense-equipment", "discharge-defense-equipment"}, uses = {"turrets", "laser", "military-science-pack"}}
    ["laser-turret-speed-2"] = {used_in = {"laser-turret-speed-3"}, uses = {"laser-turret-speed-1"}}
    ["laser-turret-speed-3"] = {used_in = {"laser-turret-speed-4"}, uses = {"laser-turret-speed-2"}}
    ["laser-turret-speed-4"] = {used_in = {"laser-turret-speed-5"}, uses = {"laser-turret-speed-3"}}
    ["laser-turret-speed-5"] = {used_in = {"laser-turret-speed-6"}, uses = {"laser-turret-speed-4"}}
    ["laser-turret-speed-6"] = {used_in = {"laser-turret-speed-7"}, uses = {"laser-turret-speed-5"}}
    ["laser-turret-speed-7"] = {uses = {"laser-turret-speed-6"}}
    ["artillery-shell-range-1"] = {uses = {"artillery", "space-science-pack"}}
    ["artillery"] = {used_in = {"artillery-shell-range-1", "artillery-shell-speed-1"}, uses = {"military-4", "tanks"}}
    ["artillery-shell-speed-1"] = {uses = {"artillery", "space-science-pack"}}
    ["follower-robot-count-1"] = {used_in = {"follower-robot-count-2"}, uses = {"combat-robotics"}}
    ["combat-robotics"] = {used_in = {"follower-robot-count-1", "combat-robotics-2"}, uses = {"military-science-pack"}}
    ["follower-robot-count-2"] = {used_in = {"follower-robot-count-3"}, uses = {"follower-robot-count-1"}}
    ["follower-robot-count-3"] = {used_in = {"follower-robot-count-4"}, uses = {"follower-robot-count-2"}}
    ["follower-robot-count-4"] = {used_in = {"follower-robot-count-5"}, uses = {"follower-robot-count-3"}}
    ["follower-robot-count-5"] = {used_in = {"follower-robot-count-6"}, uses = {"follower-robot-count-4", "combat-robotics-3"}}
    ["combat-robotics-3"] = {used_in = {"follower-robot-count-5"}, uses = {"military-4", "combat-robotics-2", "speed-module"}}
    ["follower-robot-count-6"] = {used_in = {"follower-robot-count-7"}, uses = {"follower-robot-count-5"}}
    ["follower-robot-count-7"] = {uses = {"follower-robot-count-6", "space-science-pack"}}
    ["chemical-science-pack"] = {used_in = {"military-3", "advanced-electronics-2", "braking-force-1", "laser", "low-density-structure", "electric-energy-distribution-2", "advanced-material-processing-2", "advanced-oil-processing", "uranium-processing"}, uses = {"advanced-electronics", "sulfur-processing"}}
    ["advanced-electronics"] = {used_in = {"chemical-science-pack", "modular-armor", "modules", "mining-productivity-1", "stack-inserter"}, uses = {"plastics"}}
    ["sulfur-processing"] = {used_in = {"chemical-science-pack", "explosives", "battery"}, uses = {"oil-processing"}}
    ["stone-walls"] = {used_in = {"military-science-pack", "gates"}}
    ["production-science-pack"] = {used_in = {"automation-3", "logistics-3", "effect-transmission", "coal-liquefaction", "speed-module-3", "productivity-module-3", "effectivity-module-3", "kovarex-enrichment-process", "nuclear-fuel-reprocessing"}, uses = {"productivity-module", "advanced-material-processing-2", "railway"}}
    ["productivity-module"] = {used_in = {"production-science-pack", "productivity-module-2"}, uses = {"modules"}}
    ["advanced-material-processing-2"] = {used_in = {"production-science-pack"}, uses = {"advanced-material-processing", "chemical-science-pack"}}
    ["railway"] = {used_in = {"production-science-pack", "fluid-wagon", "automated-rail-transportation", "braking-force-1"}, uses = {"logistics-2", "engine"}}
    ["utility-science-pack"] = {used_in = {"military-4", "rocket-control-unit", "logistic-system", "fusion-reactor-equipment", "personal-roboport-mk2-equipment"}, uses = {"robotics", "advanced-electronics-2", "low-density-structure"}}
    ["robotics"] = {used_in = {"utility-science-pack", "construction-robotics", "logistic-robotics", "worker-robots-speed-1", "worker-robots-storage-1"}, uses = {"electric-engine", "battery"}}
    ["advanced-electronics-2"] = {used_in = {"utility-science-pack", "power-armor", "effect-transmission", "exoskeleton-equipment", "speed-module-2", "productivity-module-2", "effectivity-module-2"}, uses = {"chemical-science-pack"}}
    ["low-density-structure"] = {used_in = {"utility-science-pack", "energy-shield-mk2-equipment", "battery-mk2-equipment", "personal-laser-defense-equipment"}, uses = {"advanced-material-processing", "chemical-science-pack"}}
    ["rocket-silo"] = {used_in = {"space-science-pack"}, uses = {"concrete", "speed-module-3", "productivity-module-3", "rocket-fuel", "rocket-control-unit"}}
    ["electric-energy-accumulators"] = {used_in = {"space-science-pack"}, uses = {"electric-energy-distribution-1", "battery"}}
    ["solar-energy"] = {used_in = {"space-science-pack", "solar-panel-equipment"}, uses = {"optics", "electronics", "steel-processing", "logistic-science-pack"}}
    ["steel-axe"] = {uses = {"steel-processing"}}
    ["steel-processing"] = {used_in = {"steel-axe", "military-2", "automation-2", "solar-energy", "heavy-armor", "electric-energy-distribution-1", "advanced-material-processing", "engine", "air-filtering"}}
    ["logistic-science-pack"] = {used_in = {"military-2", "automation-2", "circuit-network", "logistics-2", "solar-energy", "electric-energy-distribution-1", "advanced-material-processing", "toolbelt", "engine", "landfill"}}
    ["military-3"] = {used_in = {"military-4", "tanks", "explosive-rocketry", "energy-shield-mk2-equipment", "personal-laser-defense-equipment", "discharge-defense-equipment", "combat-robotics-2"}, uses = {"chemical-science-pack", "military-science-pack"}}
    ["military-4"] = {used_in = {"uranium-ammo", "atomic-bomb", "power-armor-mk2", "combat-robotics-3", "artillery"}, uses = {"military-3", "utility-science-pack", "explosives"}}
    ["explosives"] = {used_in = {"military-4", "cliff-explosives", "land-mine", "tanks", "rocketry"}, uses = {"sulfur-processing"}}
    ["uranium-ammo"] = {uses = {"uranium-processing", "military-4", "tanks"}}
    ["uranium-processing"] = {used_in = {"uranium-ammo", "nuclear-power", "kovarex-enrichment-process"}, uses = {"chemical-science-pack", "concrete"}}
    ["tanks"] = {used_in = {"uranium-ammo", "artillery"}, uses = {"automobilism", "military-3", "explosives"}}
    ["atomic-bomb"] = {uses = {"military-4", "kovarex-enrichment-process", "rocket-control-unit", "rocketry"}}
    ["kovarex-enrichment-process"] = {used_in = {"atomic-bomb"}, uses = {"production-science-pack", "uranium-processing", "rocket-fuel"}}
    ["rocket-control-unit"] = {used_in = {"atomic-bomb", "rocket-silo"}, uses = {"utility-science-pack", "speed-module"}}
    ["rocketry"] = {used_in = {"atomic-bomb", "explosive-rocketry"}, uses = {"explosives", "flammables", "military-science-pack"}}
    ["electronics"] = {used_in = {"fast-inserter", "automation-2", "circuit-network", "solar-energy", "electric-energy-distribution-1", "radar", "air-filtering"}, uses = {"automation"}}
    ["automation"] = {used_in = {"electronics", "air-filtering"}}
    ["fast-inserter"] = {used_in = {"stack-inserter"}, uses = {"electronics"}}
    ["automation-2"] = {used_in = {"research-speed-1", "concrete", "fluid-handling", "air-filtering-mk2"}, uses = {"electronics", "steel-processing", "logistic-science-pack"}}
    ["automation-3"] = {used_in = {"air-filtering-mk3"}, uses = {"speed-module", "production-science-pack"}}
    ["speed-module"] = {used_in = {"automation-3", "rocket-control-unit", "speed-module-2", "combat-robotics-3"}, uses = {"modules"}}
    ["cliff-explosives"] = {uses = {"explosives", "military-2"}}
    ["flammables"] = {used_in = {"flamethrower", "rocketry", "rocket-fuel"}, uses = {"oil-processing"}}
    ["oil-processing"] = {used_in = {"flammables", "sulfur-processing", "plastics"}, uses = {"fluid-handling"}}
    ["land-mine"] = {uses = {"explosives", "military-science-pack"}}
    ["circuit-network"] = {uses = {"electronics", "logistic-science-pack"}}
    ["plastics"] = {used_in = {"advanced-electronics", "air-filtering"}, uses = {"oil-processing"}}
    ["logistics-2"] = {used_in = {"railway", "automobilism", "stack-inserter"}, uses = {"logistics", "logistic-science-pack"}}
    ["engine"] = {used_in = {"railway", "automobilism", "fluid-handling"}, uses = {"steel-processing", "logistic-science-pack"}}
    ["fluid-wagon"] = {uses = {"railway", "fluid-handling"}}
    ["fluid-handling"] = {used_in = {"fluid-wagon", "oil-processing"}, uses = {"automation-2", "engine"}}
    ["automated-rail-transportation"] = {used_in = {"rail-signals"}, uses = {"railway"}}
    ["rail-signals"] = {uses = {"automated-rail-transportation"}}
    ["braking-force-1"] = {used_in = {"braking-force-2"}, uses = {"railway", "chemical-science-pack"}}
    ["braking-force-2"] = {used_in = {"braking-force-3"}, uses = {"braking-force-1"}}
    ["braking-force-3"] = {used_in = {"braking-force-4"}, uses = {"braking-force-2"}}
    ["braking-force-4"] = {used_in = {"braking-force-5"}, uses = {"braking-force-3"}}
    ["braking-force-5"] = {used_in = {"braking-force-6"}, uses = {"braking-force-4"}}
    ["braking-force-6"] = {used_in = {"braking-force-7"}, uses = {"braking-force-5"}}
    ["braking-force-7"] = {uses = {"braking-force-6"}}
    ["automobilism"] = {used_in = {"tanks"}, uses = {"logistics-2", "engine"}}
    ["logistics"] = {used_in = {"logistics-2"}}
    ["logistics-3"] = {uses = {"production-science-pack", "lubricant"}}
    ["lubricant"] = {used_in = {"logistics-3", "electric-engine"}, uses = {"advanced-oil-processing"}}
    ["optics"] = {used_in = {"solar-energy", "laser"}}
    ["battery"] = {used_in = {"laser", "robotics", "electric-energy-accumulators", "battery-equipment"}, uses = {"sulfur-processing"}}
    ["explosive-rocketry"] = {uses = {"rocketry", "military-3"}}
    ["heavy-armor"] = {used_in = {"modular-armor"}, uses = {"military", "steel-processing"}}
    ["modular-armor"] = {used_in = {"power-armor", "solar-panel-equipment"}, uses = {"heavy-armor", "advanced-electronics"}}
    ["power-armor"] = {used_in = {"power-armor-mk2", "energy-shield-mk2-equipment", "battery-mk2-equipment", "personal-laser-defense-equipment", "discharge-defense-equipment", "fusion-reactor-equipment"}, uses = {"modular-armor", "electric-engine", "advanced-electronics-2"}}
    ["electric-engine"] = {used_in = {"power-armor", "robotics", "exoskeleton-equipment"}, uses = {"lubricant"}}
    ["power-armor-mk2"] = {uses = {"power-armor", "military-4", "speed-module-2", "effectivity-module-2"}}
    ["speed-module-2"] = {used_in = {"power-armor-mk2", "speed-module-3"}, uses = {"speed-module", "advanced-electronics-2"}}
    ["effectivity-module-2"] = {used_in = {"power-armor-mk2", "effectivity-module-3"}, uses = {"effectivity-module", "advanced-electronics-2"}}
    ["turrets"] = {used_in = {"laser-turrets"}}
    ["gates"] = {uses = {"stone-walls", "military-2"}}
    ["rocket-fuel"] = {used_in = {"rocket-silo", "kovarex-enrichment-process"}, uses = {"flammables", "advanced-oil-processing"}}
    ["advanced-oil-processing"] = {used_in = {"rocket-fuel", "lubricant", "coal-liquefaction"}, uses = {"chemical-science-pack"}}
    ["advanced-material-processing"] = {used_in = {"low-density-structure", "advanced-material-processing-2", "concrete"}, uses = {"steel-processing", "logistic-science-pack"}}
    ["concrete"] = {used_in = {"rocket-silo", "uranium-processing"}, uses = {"advanced-material-processing", "automation-2"}}
    ["speed-module-3"] = {used_in = {"rocket-silo"}, uses = {"speed-module-2", "production-science-pack"}}
    ["productivity-module-3"] = {used_in = {"rocket-silo"}, uses = {"productivity-module-2", "production-science-pack"}}
    ["research-speed-1"] = {used_in = {"research-speed-2"}, uses = {"automation-2"}}
    ["research-speed-2"] = {used_in = {"research-speed-3"}, uses = {"research-speed-1"}}
    ["research-speed-3"] = {used_in = {"research-speed-4"}, uses = {"research-speed-2"}}
    ["research-speed-4"] = {used_in = {"research-speed-5"}, uses = {"research-speed-3"}}
    ["research-speed-5"] = {used_in = {"research-speed-6"}, uses = {"research-speed-4"}}
    ["research-speed-6"] = {uses = {"research-speed-5"}}
    ["electric-energy-distribution-1"] = {used_in = {"electric-energy-distribution-2", "electric-energy-accumulators"}, uses = {"electronics", "steel-processing", "logistic-science-pack"}}
    ["electric-energy-distribution-2"] = {uses = {"electric-energy-distribution-1", "chemical-science-pack"}}
    ["effect-transmission"] = {uses = {"advanced-electronics-2", "production-science-pack"}}
    ["toolbelt"] = {uses = {"logistic-science-pack"}}
    ["landfill"] = {uses = {"logistic-science-pack"}}
    ["construction-robotics"] = {used_in = {"personal-roboport-equipment"}, uses = {"robotics"}}
    ["logistic-robotics"] = {used_in = {"logistic-system", "character-logistic-slots-1", "character-logistic-trash-slots-1"}, uses = {"robotics"}}
    ["logistic-system"] = {uses = {"utility-science-pack", "logistic-robotics"}}
    ["worker-robots-speed-1"] = {used_in = {"worker-robots-speed-2"}, uses = {"robotics"}}
    ["worker-robots-speed-2"] = {used_in = {"worker-robots-speed-3"}, uses = {"worker-robots-speed-1"}}
    ["worker-robots-speed-3"] = {used_in = {"worker-robots-speed-4"}, uses = {"worker-robots-speed-2"}}
    ["worker-robots-speed-4"] = {used_in = {"worker-robots-speed-5"}, uses = {"worker-robots-speed-3"}}
    ["worker-robots-speed-5"] = {used_in = {"worker-robots-speed-6"}, uses = {"worker-robots-speed-4"}}
    ["worker-robots-speed-6"] = {uses = {"worker-robots-speed-5", "space-science-pack"}}
    ["worker-robots-storage-1"] = {used_in = {"worker-robots-storage-2"}, uses = {"robotics"}}
    ["worker-robots-storage-2"] = {used_in = {"worker-robots-storage-3"}, uses = {"worker-robots-storage-1"}}
    ["worker-robots-storage-3"] = {uses = {"worker-robots-storage-2"}}
    ["character-logistic-slots-1"] = {used_in = {"character-logistic-slots-2"}, uses = {"logistic-robotics"}}
    ["character-logistic-slots-2"] = {used_in = {"character-logistic-slots-3"}, uses = {"character-logistic-slots-1"}}
    ["character-logistic-slots-3"] = {used_in = {"character-logistic-slots-4"}, uses = {"character-logistic-slots-2"}}
    ["character-logistic-slots-4"] = {used_in = {"character-logistic-slots-5"}, uses = {"character-logistic-slots-3"}}
    ["character-logistic-slots-5"] = {used_in = {"character-logistic-slots-6"}, uses = {"character-logistic-slots-4"}}
    ["character-logistic-slots-6"] = {uses = {"character-logistic-slots-5"}}
    ["character-logistic-trash-slots-1"] = {used_in = {"character-logistic-trash-slots-2"}, uses = {"logistic-robotics"}}
    ["character-logistic-trash-slots-2"] = {used_in = {"character-logistic-trash-slots-3", "auto-character-logistic-trash-slots"}, uses = {"character-logistic-trash-slots-1"}}
    ["character-logistic-trash-slots-3"] = {used_in = {"character-logistic-trash-slots-4"}, uses = {"character-logistic-trash-slots-2"}}
    ["character-logistic-trash-slots-4"] = {used_in = {"character-logistic-trash-slots-5"}, uses = {"character-logistic-trash-slots-3"}}
    ["character-logistic-trash-slots-5"] = {uses = {"character-logistic-trash-slots-4"}}
    ["auto-character-logistic-trash-slots"] = {uses = {"character-logistic-trash-slots-2"}}
    ["energy-shield-equipment"] = {used_in = {"energy-shield-mk2-equipment"}, uses = {"solar-panel-equipment", "military-science-pack"}}
    ["solar-panel-equipment"] = {used_in = {"energy-shield-equipment", "night-vision-equipment", "belt-immunity-equipment", "battery-equipment", "personal-laser-defense-equipment", "discharge-defense-equipment", "exoskeleton-equipment", "personal-roboport-equipment"}, uses = {"modular-armor", "solar-energy"}}
    ["night-vision-equipment"] = {uses = {"solar-panel-equipment"}}
    ["belt-immunity-equipment"] = {uses = {"solar-panel-equipment"}}
    ["energy-shield-mk2-equipment"] = {uses = {"energy-shield-equipment", "military-3", "low-density-structure", "power-armor"}}
    ["battery-equipment"] = {used_in = {"battery-mk2-equipment"}, uses = {"battery", "solar-panel-equipment"}}
    ["battery-mk2-equipment"] = {uses = {"battery-equipment", "low-density-structure", "power-armor"}}
    ["personal-laser-defense-equipment"] = {uses = {"laser-turrets", "military-3", "low-density-structure", "power-armor", "solar-panel-equipment"}}
    ["discharge-defense-equipment"] = {uses = {"laser-turrets", "military-3", "power-armor", "solar-panel-equipment"}}
    ["fusion-reactor-equipment"] = {uses = {"utility-science-pack", "power-armor", "military-science-pack"}}
    ["exoskeleton-equipment"] = {uses = {"advanced-electronics-2", "electric-engine", "solar-panel-equipment"}}
    ["personal-roboport-equipment"] = {used_in = {"personal-roboport-mk2-equipment"}, uses = {"construction-robotics", "solar-panel-equipment"}}
    ["personal-roboport-mk2-equipment"] = {uses = {"personal-roboport-equipment", "utility-science-pack"}}
    ["coal-liquefaction"] = {uses = {"advanced-oil-processing", "production-science-pack"}}
    ["modules"] = {used_in = {"speed-module", "productivity-module", "effectivity-module"}, uses = {"advanced-electronics"}}
    ["productivity-module-2"] = {used_in = {"productivity-module-3"}, uses = {"productivity-module", "advanced-electronics-2"}}
    ["effectivity-module"] = {used_in = {"effectivity-module-2"}, uses = {"modules"}}
    ["effectivity-module-3"] = {uses = {"effectivity-module-2", "production-science-pack"}}
    ["combat-robotics-2"] = {used_in = {"combat-robotics-3"}, uses = {"combat-robotics", "military-3", "laser"}}
    ["nuclear-power"] = {used_in = {"nuclear-fuel-reprocessing"}, uses = {"uranium-processing"}}
    ["nuclear-fuel-reprocessing"] = {uses = {"nuclear-power", "production-science-pack"}}
    ["mining-productivity-1"] = {used_in = {"mining-productivity-2"}, uses = {"advanced-electronics"}}
    ["mining-productivity-2"] = {used_in = {"mining-productivity-3"}, uses = {"mining-productivity-1"}}
    ["mining-productivity-3"] = {used_in = {"mining-productivity-4"}, uses = {"mining-productivity-2"}}
    ["mining-productivity-4"] = {uses = {"mining-productivity-3", "space-science-pack"}}
    ["radar"] = {uses = {"electronics"}}
    ["stack-inserter"] = {used_in = {"inserter-capacity-bonus-1"}, uses = {"fast-inserter", "logistics-2", "advanced-electronics"}}
    ["inserter-capacity-bonus-1"] = {used_in = {"inserter-capacity-bonus-2"}, uses = {"stack-inserter"}}
    ["inserter-capacity-bonus-2"] = {used_in = {"inserter-capacity-bonus-3"}, uses = {"inserter-capacity-bonus-1"}}
    ["inserter-capacity-bonus-3"] = {used_in = {"inserter-capacity-bonus-4"}, uses = {"inserter-capacity-bonus-2"}}
    ["inserter-capacity-bonus-4"] = {used_in = {"inserter-capacity-bonus-5"}, uses = {"inserter-capacity-bonus-3"}}
    ["inserter-capacity-bonus-5"] = {used_in = {"inserter-capacity-bonus-6"}, uses = {"inserter-capacity-bonus-4"}}
    ["inserter-capacity-bonus-6"] = {used_in = {"inserter-capacity-bonus-7"}, uses = {"inserter-capacity-bonus-5"}}
    ["inserter-capacity-bonus-7"] = {uses = {"inserter-capacity-bonus-6"}}
    ["air-filtering"] = {used_in = {"air-filtering-mk2", "air-filter-recycling"}, uses = {"plastics", "steel-processing", "electronics", "automation"}}
    ["air-filtering-mk2"] = {used_in = {"air-filtering-mk3"}, uses = {"air-filtering", "automation-2"}}
    ["air-filtering-mk3"] = {used_in = {"air-filtering-mk4"}, uses = {"air-filtering-mk2", "automation-3"}}
    ["air-filtering-mk4"] = {used_in = {"air-filtering-mk5"}, uses = {"air-filtering-mk3"}}
    ["air-filtering-mk5"] = {used_in = {"air-filtering-mk6"}, uses = {"air-filtering-mk4"}}
    ["air-filtering-mk6"] = {uses = {"air-filtering-mk5"}}
    ["air-filter-recycling"] = {used_in = {"advanced-air-filter-recycling"}, uses = {"air-filtering"}}
    ["advanced-air-filter-recycling"] = {uses = {"air-filter-recycling"}}
  }